
' Program to demonstrate the use of the hardware capture
' module to measure the period of a frequency input.
'
' Input signal should be connected to RC2/CCP1

		Include "PROTON_4.INC"

		Dim Period as Word					' Word variable that stores the value
        
		Symbol Capture = PIR1.2				' CCP1 capture flag
		Symbol Overflow	= PIR1.0			' Timer1 overflow flag

		CCP1CON = %00000100					' Enable the CCP1 capture, falling edge
		T1CON = %00000001					' TMR1 prescale=1, and turn it on (1uS per count)

Loop:
		While Capture = 0 : Wend			' Wait here until captured 
        
		Period.lowbyte = CCPR1L				' Store the captured value in
		Period.highbyte = CCPR1H			' period variable
	
		If Overflow = 0 Then				' Skip the output if the timer overflowed
			Rsout "Input Period: " , @Period , "uS", 10,13	' Output
		Endif

		Capture = 0							' Clear the capture flag
	
Reset:
		While Capture = 0 : Wend			' Wait for beginning of next period
		TMR1L = 0							' Clear Timer1 low register
		TMR1H = 0							' Clear Timer1 high register
		Capture = 0							' Clear capture flag
		Overflow = 0						' Clear overflow flag
	
		Goto loop							' Do it forever
	

	
