' PicBasic Plus program to read and write to I2C Serial Eeproms
'
' Write to the first 16 locations of an external Serial Eeprom
' Read first 16 locations back and send to LCD repeatedly
' Note: for serial eeproms with WORD-sized address

       	Device 16F877
		Declare XTAL 4
        REMARKS	ON
                
' LCD pin Assignments
        Declare	LCD_DTPIN		PORTD.0
        Declare	LCD_RSPIN		PORTE.0
        Declare	LCD_ENPIN		PORTE.1
        Declare LCD_LINES		2
        Declare LCD_INTERFACE	8

		Declare SCL_PIN			PORTC.3
        Declare SDA_PIN			PORTC.4             ' Data pin

		Dim W0	as	Word                    		' Address
		Dim B1	as	Byte                    		' Data 1
		Dim B2	as	Byte                    		' Data 2

        ADCON1 = 7                      			' Set PORTA and PORTE to digital

        For W0 = 0 To 15                			' Loop 16 times
        	B1 = W0 + 10           					' B1 is data for SEEPROM
        	Busout $A0,W0,[B1]    					' Write each location
        	Delayms 10                				' Delay 10ms after each write
        Next

loop:   Cls
		For W0 = 0 To 15 Step 2         			' Loop 8 times
        	Busin $A1,W0,[B1,B2]  					' Read 2 locations in a row
        	Print at 1,1,#W0,": ",#B1," ",#B2," "  	' Display 2 locations
        	Delayms 1000
        Next

        Goto loop

