' Program to display result of ADC in 3 segment bargraph.
' The last LED in the graph dims or brightens with changes in the 
' analog input.

' Define ONINT_USED to allow use of the boot loader.
' This will not affect normal program operation.
		
        Include "PROTON_4.INC"


' Define ADCIN parameters
'		Define  ADC_BITS        8	' Set number of bits in result
'		Define  ADC_CLOCK       3	' Set clock source (3=rc)
'		Define  ADC_SAMPLEUS    50	' Set sampling time in uS

		Adval	Var	Byte			' ADC result variable
		I	Var     Byte    		' For-loop variable
		Position Var	Byte		' LED position variable
		Bright	Var	Byte			' Brightness variable


        ADCON1 = %00000010			' Set PORTA analog

Loop:   Adcin 0, Adval				' Store ADC value to adval
	
		Position = Adval / 85		' Position of last lit LED
		Bright = (Adval // 85) * 3	' Brightness of last lit LED

		For I = 0 To 2				' Set each LED
			If I < Position Then
				High I				' Turn on if lower than last lit LED 
			Else
				Low I				' Turn off if higher than last lit
			Endif
		Next

		PWM Position,Bright,5		' Dim the last LED

        Goto Loop					' Do it forever

        End

