' Program to measure voltage (0-5VDC)
' and display on LCD with 2 decimal places
'
' This program uses the */ operator to scale the
' ADC result from 0-1023 to 0-500.  The */ performs
' a divide by 256 automatically, allowing math which
' would normally exceed the limit of a word variable.
'
' Connect analog input to channel-0 (RA0)

		Include "PROTON_4.INC"

' Define ADCIN parameters
'		DEFINE  ADC_BITS        10     	' Set number of bits in result
'		DEFINE  ADC_CLOCK       3     	' Set clock source (3=rc)
'		DEFINE  ADC_SAMPLEUS    50    	' Set sampling time in uS

		Adval  VAR WORD					' Create adval to store result


		TRISA = %11111111		' Set PORTA to all input
        ADCON1 = %10000010		' Set PORTA analog and right justify result

        Delayms 500       				' Wait .5 second

loop: 	Adcin 0, Adval					' Read channel 0 to adval (0-1023)

		Adval = (Adval */ 500) >> 2		' equates to: (adval * 500)/1024

	    Cls  				' Clear LCD
        Print "DC Volts= ",Dec (Adval/100),".", Dec2 Adval	' Display the decimal value  

        Delayms 100       				' Wait .1 second

        Goto Loop       				' Do it forever

